// \[geXg ̂P
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#ifdef __cplusplus
#include <algorithm>
#include <string>
#endif

#ifndef TYPE
#define TYPE 	int
#define QSORT_INT
#endif


#define swap(a,b)	do { TYPE tmp = (a); (a) = (b); (b) = tmp; } while (0)



// ouE\[g
void bubble_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 0; i < size-1; ++i) {
		for (j = size; --j > i;) {
			if (data[j] < data[j-1])
				swap(data[j], data[j-1]);
		}
	}
}


// I\[g
void selection_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 0; i < size; ++i) {
	    size_t  min = i;
	    for (j = i+1; j < size; ++j) {
	    	if (data[j] < data[min])
	    		min = j;
	    }
	    swap(data[i], data[min]) ;
	}
}


// }\[g
void insert_sort(TYPE* data, size_t size) {
	size_t	i, j;
	for (i = 1; i < size; ++i) {
		TYPE  	tmp = data[i];
		for (j = i; j > 0 && tmp < data[j-1]; --j)
			data[j] = data[j-1];
		data[j] = tmp;
	}
}


// }\[g (Ȃ炨)
void yane_insert_sort(TYPE* data, size_t size) {
	size_t i, j;
	for (i = 1; i < size; i++) {
		TYPE tmp = data[i];
		if (data[i-1] > tmp) {
			j = i;
			do {
				data[j] = data[j-1];
				--j;
			} while ( j > 0 && data[j-1] > tmp);
			data[j] = tmp;
		}
	}
}


// }\[g(old) 2007܂łwikipediaɍڂĂo[W.
void old_insert_sort(TYPE* data, size_t size) {
	size_t	i, j, k;
	for (i = 0; ++i < size;) {
		for (j = i, k = i-1; j > 0 && data[j] < data[k]; --j, --k)
			swap(data[j], data[k]);
	}
}


// RE\[g
void comb_sort(TYPE* data, size_t size) {
    size_t h    = size * 10 / 13;
    for (;;) {
        int 	swapFlag = 0;
        size_t	i 		 = 0;
        for (i = 0; i + h < size; ++i) {
            if (data[i + h] < data[i]) {
                swap(data[i + h], data[i]);
                swapFlag = 1;
            }
        }
        if (h <= 1) {
            if (!swapFlag)
                break;
        } else {
            h = h * 10 / 13;
        }
    }
}


// RE\[g11
void comb_sort11(TYPE* data, size_t size) {
    size_t 		h		= size * 10 / 13;
    for (;;) {
		size_t	i;
        int 	swapFlag = 0;
        for (i = 0; i + h < size; ++i) {
            if (data[i + h] < data[i]) {
                swap(data[i + h], data[i]);
                swapFlag = 1;
            }
        }
        if (h <= 1) {
            if (!swapFlag)
                break;
        } else if ((h == 9) | (h == 10)) {
			h = 11;
        } else {
            h = h * 10 / 13;
        }
    }
}


// HvȂquick\[g.
void quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 1)
		return;
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	quick_sort(data, l - data);
	quick_sort(l   , e - l  );
}



// quick\[g+}\[g (32ȉɂȂ}\[gɐؑ)
void ex_quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 32) {
		if (size <= 1)
			return;
		insert_sort(data, size);
		return;
	}
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	ex_quick_sort(data, l - data);
	ex_quick_sort(l   , e - l  );
}



// quick\[g+}\[g (32ȉɂȂ}\[gɐؑ)
void y_quick_sort(TYPE* data, size_t size) {
	TYPE  m;
	TYPE *l, *r, *e;
	if (size <= 32) {
		if (size <= 1)
			return;
		yane_insert_sort(data, size);
		return;
	}
	m = data[size / 2];
	l = data;
	e = data + size;
	r = e - 1;
	for (;;) {
		while (*l < m)
			++l;
		while (m < *r)
			--r;
		if (l >= r)
			break;
		swap(*l, *r);
		++l;
	}
	y_quick_sort(data, l - data);
	y_quick_sort(l   , e - l  );
}


#ifndef UNUSE_QSORT
// qsortp̔r֐.
int qsort_cmp(const void* a0, const void* b0) {
	const TYPE* a = (const TYPE* )a0;
	const TYPE* b = (const TYPE* )b0;
  #if defined QSORT_INT
	return *a - *b;
  #else
	if (*a < *b)
		return -1;
	else if (*a > *b)
		return 1;
	return 0;
  #endif
}



// CCu qsort gꍇ.
void c_qsort(TYPE* data, size_t size) {
	qsort(data, size, sizeof(TYPE), qsort_cmp);
}
#endif


#ifdef __cplusplus
// std::sort gm.
void std_sort(TYPE* data, size_t size) {
	std::sort(data, data+size);
}
#endif



// ===========================================================================
#ifdef _WIN32
#include <windows.h>
typedef unsigned __int64 PerfCnt_tick_t;
PerfCnt_tick_t PerfCnt_getTick()    { PerfCnt_tick_t c; QueryPerformanceCounter((LARGE_INTEGER*)&c); return c; }
PerfCnt_tick_t PerfCnt_tickPerSec() { static PerfCnt_tick_t s = 0; if (!s) QueryPerformanceFrequency((LARGE_INTEGER*)&s); return s; }
#else
#include <time.h>
typedef clock_t PerfCnt_tick_t;
#define PerfCnt_getTick() 			clock()
#define PerfCnt_tickPerSec() 		CLOCKS_PER_SEC
#endif


// ===========================================================================
typedef void (*SortFunc)(TYPE*, size_t size);

double benchmark(SortFunc sortFunc, size_t size, size_t count, int seed) {
	unsigned 		i, j, ofs = 0;
    PerfCnt_tick_t	elapsed, start_time;
	TYPE*	 		data    = (TYPE*) calloc(1, size * count * sizeof(TYPE) + 16);
	if (data == 0) { printf("not enough memory.\n"); exit(1); }
	srand(seed);
    for (i = 0; i < size * count; ++i)
        data[i] = rand();
    start_time  = PerfCnt_getTick();
	for (j = 0; j < count; ++j) {
	    sortFunc(&data[ofs], size);
	    ofs        += size;
	}
    elapsed    = PerfCnt_getTick() - start_time;
	free(data);
	return elapsed * 1.0 / (PerfCnt_tickPerSec()*count);
}



struct St {
	size_t		size;
	size_t		count;
	int			on2flag;
	double		elaped[11];
};


//
int main(int argc, char *argv[]) {
	int			 on2flag  = 1;
	St			 st[128];
	const char*	 ttl[12] = {0};
	unsigned 	 i;
	unsigned 	 n    = 0;
	unsigned 	 seed = 1;	//time(0);
	if (argc < 3) {
		printf("usage> sort_test1 [-na] size1 count1 [size2 count2 ...]\n"
			   " -na ȍ~O(n^2)ȃASY\n"
		);
		return 1;
	}
	for (i = 1; i < argc && n < 128; i += 2) {
		if (strcmp(argv[i],"-na") == 0) {
			on2flag  = 0;
			++i;
		}
		memset(&st[n], 0, sizeof st[0]);
		st[n].size    = (i   < argc) ? atoi(argv[i+0]) : 10;
    	st[n].count   = (i+1 < argc) ? atoi(argv[i+1]) : 1;
		st[n].on2flag = on2flag;
    	++n;
    }

    printf("\nsort_test1 : sizeof(TYPE)=%dbytes\n", sizeof(TYPE));
	for (i = 0; i < n; ++i) {
		St* t = &st[i];
	    printf(" %9d,  %9d\n", t->size, t->count);
	    if (t->on2flag) {	// O(n^2)
			t->elaped[ 0] = benchmark(&bubble_sort     , t->size, t->count, seed);	ttl[ 0] = "bubble sort       ";
			t->elaped[ 1] = benchmark(&selection_sort  , t->size, t->count, seed);	ttl[ 1] = "selection sort    ";
			t->elaped[ 2] = benchmark(&insert_sort     , t->size, t->count, seed);	ttl[ 2] = "insert sort       ";
			t->elaped[ 3] = benchmark(&yane_insert_sort, t->size, t->count, seed);	ttl[ 3] = "insert sort(yane) ";
		}
		{
			t->elaped[ 4] = benchmark(&comb_sort      , t->size, t->count, seed);	ttl[ 4] = "comb sort         ";
			t->elaped[ 5] = benchmark(&comb_sort11    , t->size, t->count, seed);	ttl[ 5] = "comb sort11       ";
			t->elaped[ 6] = benchmark(&quick_sort     , t->size, t->count, seed);	ttl[ 6] = "quick sort        ";
			t->elaped[ 7] = benchmark(&ex_quick_sort  , t->size, t->count, seed);	ttl[ 7] = "quick+insert sort ";
			t->elaped[ 8] = benchmark(&y_quick_sort   , t->size, t->count, seed);	ttl[ 8] = "quick+insert(yane)";
		  #ifdef __cplusplus
			t->elaped[ 9] = benchmark(&std_sort       , t->size, t->count, seed);	ttl[ 9] = "std::sort         ";
		  #endif
		  #ifndef UNUSE_QSORT
			t->elaped[10] = benchmark(&c_qsort        , t->size, t->count, seed);	ttl[10] = "qsort             ";
		  #endif
		}
	}
	ttl[11] = 0;

	printf("\n");
	printf("%18s ,", "");
	for (unsigned i = 0; i < n; ++i) {
		printf("%9d,", st[i].size);
	};
	printf("\n");
	for (unsigned j = 0; j < 11; ++j) {
		if (ttl[j] == 0)
			continue;
		printf("%-18s ,", ttl[j]);
		for (unsigned i = 0; i < n; ++i) {
			double e = st[i].elaped[j]*1000000.0;
			if (e > 0)
				printf("%11.3f,", e);
			else
				printf("%11s,", "---");
		};
		printf("\n");
	}
    return 0;
}
